<?php
/**
 * Multi Blogger Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package multi_blogger
 */

if( ! function_exists( 'multi_blogger_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function multi_blogger_customize_register( $wp_customize ) {
    require get_parent_theme_file_path('/inc/controls/changeable-icon.php');

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Multi_Blogger_Control_Sortable' ); 
    

    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'multi-blogger' );
    }
	
    /* Option list of all post */	
    $multi_blogger_options_posts = array();
    $multi_blogger_options_posts_obj = get_posts('posts_per_page=-1');
    $multi_blogger_options_posts[''] = esc_html__( 'Choose Post', 'multi-blogger' );
    foreach ( $multi_blogger_options_posts_obj as $multi_blogger_posts ) {
    	$multi_blogger_options_posts[$multi_blogger_posts->ID] = $multi_blogger_posts->post_title;
    }
    
    /* Option list of all categories */
    $multi_blogger_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $multi_blogger_option_categories = array();
    $multi_blogger_category_lists = get_categories( $multi_blogger_args );
    $multi_blogger_option_categories[''] = esc_html__( 'Choose Category', 'multi-blogger' );
    foreach( $multi_blogger_category_lists as $multi_blogger_category ){
        $multi_blogger_option_categories[$multi_blogger_category->term_id] = $multi_blogger_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'multi-blogger' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'multi-blogger' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */
    
    /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => true,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'multi-blogger' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'multi-blogger' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting( 'multi_blogger_site_title_size', array(
        'default'           => 25, // Default font size in pixels
        'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
    ) );

    // Add control for site title size
    $wp_customize->add_control( 'multi_blogger_site_title_size', array(
        'type'        => 'number',
        'section'     => 'title_tagline', // You can change this section to your preferred section
        'label'       => __( 'Site Title Font Size (px)', 'multi-blogger' ),
        'input_attrs' => array(
            'min'  => 10,
            'max'  => 100,
            'step' => 1,
        ),
    ) );

    /** Post & Pages Settings */
    $wp_customize->add_panel( 
        'multi_blogger_post_settings',
         array(
            'priority' => 11,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'multi-blogger' ),
            'description' => esc_html__( 'Customize Post & Pages Settings', 'multi-blogger' ),
        ) 
    );

        /** Post Layouts */
    
    $wp_customize->add_section(
        'multi_blogger_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'multi-blogger' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'multi_blogger_post_settings',
        )
    );

    $wp_customize->add_setting('multi_blogger_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'multi_blogger_sanitize_post_layout',
    ));

    $wp_customize->add_control('multi_blogger_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'multi-blogger'),
        'section'  => 'multi_blogger_post_layout_section',
        'settings' => 'multi_blogger_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'multi-blogger'),
            'left-sidebar'   => __('Left Sidebar', 'multi-blogger'),
            'one-column'   => __('One Column', 'multi-blogger'),
            'three-column'   => __('Three Columns', 'multi-blogger'),
            'four-column'   => __('Four Columns', 'multi-blogger'),
            'grid-layout'   => __('Grid Layout', 'multi-blogger')
        ),
    ));

     /** Post Layouts Ends */
     
    /** Post Settings */
    $wp_customize->add_section(
        'multi_blogger_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'multi-blogger' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'multi_blogger_post_settings',
        )
    );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'multi_blogger_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'multi-blogger' ),
            'section'     => 'multi_blogger_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'multi_blogger_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'multi-blogger' ),
            'section'     => 'multi_blogger_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'multi_blogger_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'multi-blogger' ),
            'section'     => 'multi_blogger_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'multi_blogger_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'multi-blogger' ),
            'section'     => 'multi_blogger_post_settings',
            'type'        => 'checkbox',
        )
    );
    /** Post ReadMore control */
     $wp_customize->add_setting( 'multi_blogger_read_more_setting', array(
        'default'           => true,
        'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'multi_blogger_read_more_setting', array(
        'type'        => 'checkbox',
        'section'     => 'multi_blogger_post_settings', 
        'label'       => __( 'Display Read More Button', 'multi-blogger' ),
    ) );

    $wp_customize->add_setting('multi_blogger_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'multi_blogger_sanitize_sortable',
    ));
    $wp_customize->add_control(new Multi_Blogger_Control_Sortable($wp_customize, 'multi_blogger_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'multi-blogger'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'multi-blogger') ,
        'section' => 'multi_blogger_post_settings',
        'choices' => array(
            'heading' => __('heading', 'multi-blogger') ,
            'author' => __('author', 'multi-blogger') ,
            'featured-image' => __('featured-image', 'multi-blogger') ,
            'content' => __('content', 'multi-blogger') ,
            'button' => __('button', 'multi-blogger') ,
        ) ,
    )));

    /** Post Settings Ends */

     /** Single Post Settings */
    $wp_customize->add_section(
        'multi_blogger_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'multi-blogger' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'multi_blogger_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'multi_blogger_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'multi-blogger' ),
            'section'     => 'multi_blogger_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'multi_blogger_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'multi-blogger' ),
            'section'     => 'multi_blogger_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    //Global Color
    $wp_customize->add_section(
        'multi_blogger_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'multi-blogger' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'multi_blogger_general_settings',
        )
    );

    $wp_customize->add_setting('multi_blogger_primary_color', array(
        'default'           => '#164160',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'multi_blogger_primary_color', array(
        'label'    => __('Theme Primary Color', 'multi-blogger'),
        'section'  => 'multi_blogger_global_color',
        'settings' => 'multi_blogger_primary_color',
    )));    

    $wp_customize->add_setting('multi_blogger_second_color', array(
        'default'           => '#2B2B2B',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'multi_blogger_second_color', array(
        'label'    => __('Theme Secondary Color', 'multi-blogger'),
        'section'  => 'multi_blogger_global_color',
        'settings' => 'multi_blogger_second_color',
    )));

    /** Single Post Settings Ends */

         // Typography Settings Section
    $wp_customize->add_section('multi_blogger_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'multi-blogger'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'multi_blogger_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'multi-blogger'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Unbounded'         => 'Unbounded, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('multi_blogger_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'multi_blogger_sanitize_choicess',
    ));
    $wp_customize->add_control('multi_blogger_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'multi-blogger'),
        'section' => 'multi_blogger_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('multi_blogger_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'multi_blogger_sanitize_choicess',
    ));
    $wp_customize->add_control('multi_blogger_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'multi-blogger'),
        'section' => 'multi_blogger_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'multi_blogger_general_settings',
         array(
            'priority' => 11,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'multi-blogger' ),
            'description' => esc_html__( 'Customize General Settings', 'multi-blogger' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'multi_blogger_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'multi-blogger' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'multi_blogger_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'multi_blogger_header_preloader', 
        array(
            'default' => false,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_header_preloader',
        array(
            'label'       => __( 'Show Preloader', 'multi-blogger' ),
            'section'     => 'multi_blogger_general_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('multi_blogger_loader_layout_setting', array(
        'default' => 'load',
        'sanitize_callback' => 'sanitize_text_field',
    ));

    // Add control for loader layout
    $wp_customize->add_control('multi_blogger_loader_layout_control', array(
        'label' => __('Preloader Layout', 'multi-blogger'),
        'section' => 'multi_blogger_general_settings',
        'settings' => 'multi_blogger_loader_layout_setting',
        'type' => 'select',
        'choices' => array(
            'load' => __('Preloader 1', 'multi-blogger'),
            'load-one' => __('Preloader 2', 'multi-blogger'),
            'ctn-preloader' => __('Preloader 3', 'multi-blogger'),
        ),
    ));

    /** Header Section Settings */
    $wp_customize->add_section(
        'multi_blogger_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'multi-blogger' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'multi_blogger_home_page_settings',
        )
    );

    /** Sticky Header control */
    $wp_customize->add_setting( 
        'multi_blogger_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'multi-blogger' ),
            'section'     => 'multi_blogger_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'multi_blogger_menu_font_weight', array(
        'default'           => '500',
        'sanitize_callback' => 'multi_blogger_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'multi_blogger_menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'multi-blogger' ),
        'section'  => 'multi_blogger_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'multi-blogger' ),
            '200' => __( '200 - Extra Light', 'multi-blogger' ),
            '300' => __( '300 - Light', 'multi-blogger' ),
            '400' => __( '400 - Normal', 'multi-blogger' ),
            '500' => __( '500 - Medium', 'multi-blogger' ),
            '600' => __( '600 - Semi Bold', 'multi-blogger' ),
            '700' => __( '700 - Bold', 'multi-blogger' ),
            '800' => __( '800 - Extra Bold', 'multi-blogger' ),
            '900' => __( '900 - Black', 'multi-blogger' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'multi_blogger_menu_text_transform', array(
        'default'           => 'capitalize',
        'sanitize_callback' => 'multi_blogger_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'multi_blogger_menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'multi-blogger' ),
        'section'  => 'multi_blogger_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'multi-blogger' ),
            'capitalize' => __( 'Capitalize', 'multi-blogger' ),
            'uppercase'  => __( 'Uppercase', 'multi-blogger' ),
            'lowercase'  => __( 'Lowercase', 'multi-blogger' ),
        ),
    ) );

    // Menu Hover Style	
    $wp_customize->add_setting('multi_blogger_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'multi_blogger_sanitize_choices'
	));
	$wp_customize->add_control('multi_blogger_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','multi-blogger'),
		'section' => 'multi_blogger_header_section_settings',
		'choices' => array(
         'None' => __('None','multi-blogger'),
         'Zoom In' => __('Zoom In','multi-blogger'),
      ),
	));

    $wp_customize->add_setting( 
        'multi_blogger_show_hide_search', 
        array(
            'default' => false ,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_show_hide_search',
        array(
            'label'       => __( 'Show Search Feild', 'multi-blogger' ),
            'section'     => 'multi_blogger_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting( 
        'multi_blogger_header_settings_upgraded_features',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control(
        'multi_blogger_header_settings_upgraded_features', 
        array(
            'type'=> 'hidden',
            'description' => "
                <div class='notice-pro-features'>
                    <div class='notice-pro-icon'>
                        <i class='fas fa-crown'></i>
                    </div>
                    <div class='notice-pro-content'>
                        <h3>Unlock Premium Features</h3>
                        <p>Enhance your website with advanced layouts, premium sections, and powerful customization tools.</p>
                    </div>
                    <div class='notice-pro-button'>
                        <a target='_blank' href='". esc_url(MULTI_BLOGGER_URL) ."' class='notice-upgrade-btn'>
                            Upgrade to Pro<i class='fas fa-rocket'></i>
                        </a>
                    </div>
                </div>
            ",
            'section' => 'multi_blogger_header_section_settings'
        )
    );

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'multi_blogger_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'multi-blogger' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'multi-blogger' ),
        ) 
    );

 /** Slider Section Settings */
    $wp_customize->add_section(
        'multi_blogger_slider_section_settings',
        array(
            'title' => esc_html__( 'Slider Section Settings', 'multi-blogger' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'multi_blogger_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'multi_blogger_slider_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_slider_setting',
        array(
            'label'       => __( 'Show Slider', 'multi-blogger' ),
            'section'     => 'multi_blogger_slider_section_settings',
            'type'        => 'checkbox',
        )
    );


    // Section Text
    $wp_customize->add_setting('multi_blogger_slider_banner_heading', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('multi_blogger_slider_banner_heading', 
        array(
        'label'       => __('Slider Title', 'multi-blogger'),
        'section'     => 'multi_blogger_slider_section_settings',   
        'settings'    => 'multi_blogger_slider_banner_heading',
        'type'        => 'text'
        )
    );

    // Section Text
    $wp_customize->add_setting('multi_blogger_slider_banner_content', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('multi_blogger_slider_banner_content', 
        array(
        'label'       => __('Slider Content', 'multi-blogger'),
        'section'     => 'multi_blogger_slider_section_settings',   
        'settings'    => 'multi_blogger_slider_banner_content',
        'type'        => 'text'
        )
    );

    // slider button text
	$wp_customize->add_setting('multi_blogger_button_text', 
    array(
	    'default'           => 'Explore more',
        'type'              => 'theme_mod',
	    'sanitize_callback' => 'sanitize_text_field',
	    'capability'        => 'edit_theme_options',
	));
	$wp_customize->add_control('multi_blogger_button_text', 
    array(
        'label'    => __('Slider Button Text', 'multi-blogger'),
	    'settings' => 'multi_blogger_button_text',
	    'section'  => 'multi_blogger_slider_section_settings',
	    'type'     => 'text',
	));

    // slider button Url
    $wp_customize->add_setting('multi_blogger_slider_btn_url', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'esc_url_raw'
        )
    );

    $wp_customize->add_control('multi_blogger_slider_btn_url', 
        array(
        'label'       => __('Slider Button URL', 'multi-blogger'),
        'section'     => 'multi_blogger_slider_section_settings',   
        'settings'    => 'multi_blogger_slider_btn_url',
        'type'        => 'url'
        )
    );

    // Post Categories
	$multi_blogger_categories = get_categories();
	$multi_blogger_cat_post = array();
	$multi_blogger_cat_post['0'] = 'Select';

	foreach ($multi_blogger_categories as $multi_blogger_category) {
	    $multi_blogger_cat_post[$multi_blogger_category->slug] = $multi_blogger_category->name;
	}

    $wp_customize->add_setting(
        'multi_blogger_slider_blog_args_',
        array(
            'default'            => '0',
            'sanitize_callback'  => 'multi_blogger_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'multi_blogger_slider_blog_args_',
        array(
            'type'     => 'select',
            'choices'  => $multi_blogger_cat_post,
            'label'    => __('Select Category to display Latest Post', 'multi-blogger'),
            'section'  => 'multi_blogger_slider_section_settings',
        )
    );

    $wp_customize->add_setting( 
        'multi_blogger_slider_settings_upgraded_features',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control(
        'multi_blogger_slider_settings_upgraded_features', 
        array(
            'type'=> 'hidden',
            'description' => "
                <div class='notice-pro-features'>
                    <div class='notice-pro-icon'>
                        <i class='fas fa-crown'></i>
                    </div>
                    <div class='notice-pro-content'>
                        <h3>Unlock Premium Features</h3>
                        <p>Enhance your website with advanced layouts, premium sections, and powerful customization tools.</p>
                    </div>
                    <div class='notice-pro-button'>
                        <a target='_blank' href='". esc_url(MULTI_BLOGGER_URL) ."' class='notice-upgrade-btn'>
                            Upgrade to Pro<i class='fas fa-rocket'></i>
                        </a>
                    </div>
                </div>
            ",
            'section' => 'multi_blogger_slider_section_settings'
        )
    );

    /** Classes Section Settings */
    $wp_customize->add_section(
        'multi_blogger_classes_section_settings',
        array(
            'title' => esc_html__( 'Services Section Settings', 'multi-blogger' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'multi_blogger_home_page_settings',
        )
    );

    /** Classes Section control */
    $wp_customize->add_setting( 
        'multi_blogger_classes_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_classes_setting',
        array(
            'label'       => __( 'Show Services Section', 'multi-blogger' ),
            'section'     => 'multi_blogger_classes_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Section Title
    $wp_customize->add_setting(
        'multi_blogger_service_title', 
        array(
            'default'           => '',
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',    
            'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control(
        'multi_blogger_service_title', 
        array(
            'label'       => __('Section Title', 'multi-blogger'),
            'section'     => 'multi_blogger_classes_section_settings',
            'settings'    => 'multi_blogger_service_title',
            'type'        => 'text'
        )
    );

    // button text
	$wp_customize->add_setting('multi_blogger_service_button_text', 
    array(
	    'default'           => 'See More Stories',
        'type'              => 'theme_mod',
	    'sanitize_callback' => 'sanitize_text_field',
	    'capability'        => 'edit_theme_options',
	));
	$wp_customize->add_control('multi_blogger_service_button_text', 
    array(
        'label'    => __('Service Button Text', 'multi-blogger'),
	    'settings' => 'multi_blogger_service_button_text',
	    'section'  => 'multi_blogger_classes_section_settings',
	    'type'     => 'text',
	));

    // button Url
    $wp_customize->add_setting('multi_blogger_service_btn_url', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'esc_url_raw'
        )
    );

    $wp_customize->add_control('multi_blogger_service_btn_url', 
        array(
        'label'       => __('Service Button URL', 'multi-blogger'),
        'section'     => 'multi_blogger_classes_section_settings',   
        'settings'    => 'multi_blogger_service_btn_url',
        'type'        => 'url'
        )
    );

    // Post Categories
	$multi_blogger_categories = get_categories();
	$multi_blogger_cat_post = array();
	$multi_blogger_cat_post['0'] = 'Select';

	foreach ($multi_blogger_categories as $multi_blogger_category) {
	    $multi_blogger_cat_post[$multi_blogger_category->slug] = $multi_blogger_category->name;
	}

    $wp_customize->add_setting(
        'multi_blogger_blog_args_',
        array(
            'default'            => '0',
            'sanitize_callback'  => 'multi_blogger_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'multi_blogger_blog_args_',
        array(
            'type'     => 'select',
            'choices'  => $multi_blogger_cat_post,
            'label'    => __('Select Category to Display Services', 'multi-blogger'),
            'section'  => 'multi_blogger_classes_section_settings',
        )
    );

    $wp_customize->add_setting( 
        'multi_blogger_classes_settings_upgraded_features',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control(
        'multi_blogger_classes_settings_upgraded_features', 
        array(
            'type'=> 'hidden',
            'description' => "
                <div class='notice-pro-features'>
                    <div class='notice-pro-icon'>
                        <i class='fas fa-crown'></i>
                    </div>
                    <div class='notice-pro-content'>
                        <h3>Unlock Premium Features</h3>
                        <p>Enhance your website with advanced layouts, premium sections, and powerful customization tools.</p>
                    </div>
                    <div class='notice-pro-button'>
                        <a target='_blank' href='". esc_url(MULTI_BLOGGER_URL) ."' class='notice-upgrade-btn'>
                            Upgrade to Pro<i class='fas fa-rocket'></i>
                        </a>
                    </div>
                </div>
            ",
            'section' => 'multi_blogger_classes_section_settings'
        )
    );

    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'multi_blogger_footer_section',
        array(
            'title' => __( 'Footer Settings', 'multi-blogger' ),
            'priority' => 70,
            'panel' => 'multi_blogger_home_page_settings',
        )
    );

    /** Footer Widget Columns */
    $wp_customize->add_setting('multi_blogger_footer_widget_areas', array(
        'default'           => 4,
        'sanitize_callback' => 'multi_blogger_sanitize_choices',
    ));

    $wp_customize->add_control('multi_blogger_footer_widget_areas', array(
        'label'    => __('Footer Widget Columns', 'multi-blogger'),
        'section'  => 'multi_blogger_footer_section',
        'settings' => 'multi_blogger_footer_widget_areas',
        'type'     => 'select',
        'choices'  => array(
		   '1'     => __('One', 'multi-blogger'),
		   '2'     => __('Two', 'multi-blogger'),
		   '3'     => __('Three', 'multi-blogger'),
		   '4'     => __('Four', 'multi-blogger')
        ),
    ));

    /** Footer Copyright control */
    $wp_customize->add_setting( 
        'multi_blogger_footer_setting', 
        array(
            'default' => true,
            'sanitize_callback' => 'multi_blogger_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'multi_blogger_footer_setting',
        array(
            'label'       => __( 'Show Footer Copyright', 'multi-blogger' ),
            'section'     => 'multi_blogger_footer_section',
            'type'        => 'checkbox',
        )
    );
    
    /** Copyright Text */
    $wp_customize->add_setting(
        'multi_blogger_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'multi_blogger_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'multi-blogger' ),
            'section' => 'multi_blogger_footer_section',
            'type' => 'text',
        )
    );  
    $wp_customize->add_setting('multi_blogger_footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );

    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'multi_blogger_footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'multi-blogger'),
                /* translators: 1: image width in pixels, 2: image height in pixels */
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'multi-blogger'), 1024, 800),
                'section' => 'multi_blogger_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('multi_blogger_background_attachment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'multi_blogger_sanitize_choices',
    ));

    $wp_customize->add_control('multi_blogger_background_attachment', array(
        'label'    => __('Footer Background Attachment', 'multi-blogger'),
        'section'  => 'multi_blogger_footer_section',
        'settings' => 'multi_blogger_background_attachment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','multi-blogger'),
            'scroll' => __('scroll','multi-blogger'),
        ),
    ));

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'multi_blogger_footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'multi_blogger_footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'multi-blogger'),
                'section' => 'multi_blogger_footer_section',
                'type' => 'color',
            )
        )
    );

     $wp_customize->add_setting('multi_blogger_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Multi_Blogger_Changeable_Icon(
        $wp_customize,'multi_blogger_scroll_icon',array(
        'label' => __('Scroll Top Icon','multi-blogger'),
        'transport' => 'refresh',
        'section'   => 'multi_blogger_footer_section',
        'type'      => 'icon'
    )));

    /** Scroll to top button shape */
    $wp_customize->add_setting('multi_blogger_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'multi_blogger_sanitize_choices',
    ));

    $wp_customize->add_control('multi_blogger_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'multi-blogger'),
        'section'  => 'multi_blogger_footer_section',
        'settings' => 'multi_blogger_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'multi-blogger' ),
            'curved-box' => __( 'Curved Box', 'multi-blogger' ),
            'circle'     => __( 'Circle', 'multi-blogger' ),
        ),
    ));

    $wp_customize->add_setting( 
        'multi_blogger_footer_settings_upgraded_features',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control(
        'multi_blogger_footer_settings_upgraded_features', 
        array(
            'type'=> 'hidden',
            'description' => "
                <div class='notice-pro-features'>
                    <div class='notice-pro-icon'>
                        <i class='fas fa-crown'></i>
                    </div>
                    <div class='notice-pro-content'>
                        <h3>Unlock Premium Features</h3>
                        <p>Enhance your website with advanced layouts, premium sections, and powerful customization tools.</p>
                    </div>
                    <div class='notice-pro-button'>
                        <a target='_blank' href='". esc_url(MULTI_BLOGGER_URL) ."' class='notice-upgrade-btn'>
                            Upgrade to Pro<i class='fas fa-rocket'></i>
                        </a>
                    </div>
                </div>
            ",
            'section' => 'multi_blogger_footer_section'
        )
    );

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'multi_blogger_404_section',
        array(
            'title' => __( '404 Page Settings', 'multi-blogger' ),
            'priority' => 70,
            'panel' => 'multi_blogger_general_settings',
        )
    );
   
    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'multi-blogger'),
        'section' => 'multi_blogger_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'multi-blogger'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('404 Page Heading', 'multi-blogger'),
        'section' => 'multi_blogger_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'multi-blogger'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('404 Page Content', 'multi-blogger'),
        'section' => 'multi_blogger_404_section',
    ));

}
add_action( 'customize_register', 'multi_blogger_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function multi_blogger_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $multi_blogger_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $multi_blogger_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'multi_blogger_customizer', get_template_directory_uri() . '/js' . $multi_blogger_build . '/customizer' . $multi_blogger_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'multi_blogger_customize_preview_js' );